> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/guides/getting-started/using-activity.md).

# Show a document in an Activity

Learn how to use DocumentActivity in Xamarin.Android for PDF editing and document viewing. Follow step-by-step instructions to integrate Apryse's Android SDK and PDFTron tools. Customize your document

{% hint style="info" %}
**This tutorial only applies to Xamarin.Android.**
{% endhint %}

Apryse's Android SDK ships with [`DocumentActivity`](https://sdk.apryse.com/api/xamarinandroid/tools/api/pdftron.PDF.Controls.DocumentActivity.html), an all-in-one document reader and PDF editor. In addition to PDF files, it also supports [viewing other file formats](/xamarin/conversion/non-pdf.md#android) such as `.docx`, `.doc`, `.pptx`, `.xlsx`, `.md`, `.cbz` and various image formats. In this activity you can also read, annotate, sign, fill in PDF forms and more.

`DocumentActivity` extends Android's [`AppCompatActivity`](https://developer.android.com/reference/androidx/appcompat/app/AppCompatActivity/) and follows [Material design guidelines](https://material.io/guidelines/).

![](https://653871032-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgjsBtuYmcKhWOdM9VCg4%2Fuploads%2Fgit-blob-ffa3eaa183402c0184a8845cef4ef7492205fd4b%2F1ed8a2fb5f4d6204964ec7788bb1094df6d78c7e-600x1200.gif?alt=media)

## Prerequisites

* [Integrated Apryse into your project](/xamarin/get-started/get-started.md) and added the `PDFTron.Android.Tools` NuGet package into your project.
* Minimum API: 21 (using AndroidX)
* Compile API: 35
* Recommended target API: 35

{% hint style="info" %}
**No trial license key required.**

The trial of Apryse Mobile SDK does not require a trial key. A commercial license key is required for use in a production environment. Please [contact sales](https://apryse.com/form/contact-sales) to purchase a commercial key or if you need any other license key assistance.
{% endhint %}

{% hint style="warning" %}
**Keep your license keys confidential.**

License keys are uniquely generated. Please make sure that it is not publicly available (e.g. in your public GitHub).
{% endhint %}

## Step 1: Update AndroidManifest.xml

1. In order to support all the features in `DocumentActivity`, we will need to add the Android permissions listed in [this table](/xamarin/learn-more/permissions.md#android-permissions-list). However if you would like to disable certain features and customize your document viewer, you should leave out unnecessary permissions.

{% hint style="warning" %}
**Storage permission**

Please note that from Android 6.0 (API 23) and up, applications need to request storage permission at runtime before accessing any files on device.
{% endhint %}

1. Enable `largeHeap`:

{% tabs %}
{% tab title="XML" %}
{% code lineNumbers="true" %}

```xml
<application ... android:largeHeap="true" android:usesCleartextTraffic="false">
</application>
```

{% endcode %}
{% endtab %}
{% endtabs %}

{% hint style="warning" %}
**If your app is targeting Android SDK version 28 or higher, you will need to add the android:usesCleartextTraffic="true" attribute in your application tag to open HTTP files in the viewer. If you are only working with HTTPS files, this is not required.**
{% endhint %}

1. If you have not done so already, add your license in the `AndroidManifest.xml` file, and also declare `DocumentActivity` in the manifest file. The final `AndroidManifest.xml` file should look something like this:

{% tabs %}
{% tab title="XML" %}
{% code lineNumbers="true" %}

```xml
<manifest ...>
    <!-- Required permissions are added here -->
    <uses-permission android:name="android.permission.INTERNET"/>
    <uses-permission android:name="android.permission.RECORD_AUDIO" />
    <!-- Add enable largeHeap -->
    <application ... android:largeHeap="true" android:usesCleartextTraffic="false">   
        
        <meta-data android:name="pdftron_license_key" android:value="your_license_key_goes_here"/>

        <!-- Document viewer activity declaration-->
        <activity android:name="com.pdftron.pdf.controls.DocumentActivity" android:configChanges="keyboardHidden|orientation|screenSize|screenLayout|smallestScreenSize" android:windowSoftInputMode="adjustPan" android:theme="@style/PDFTronAppTheme"/>
        ...
    </application>
</manifest>
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Step 2: Launch the viewer

Launch `DocumentActivity` by specifiying a local file path, an HTTP/HTTPS url, or a Content Uri:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
// from internal storage
var uri = Android.Net.Uri.FromFile(new Java.IO.File("myLocalFilePath"));
// from content uri
var uri = Android.Net.Uri.Parse("myContentUri");
// from http/https
var uri = Android.Net.Uri.Parse("myFileLink");
// from assets
var uri = Android.Net.Uri.Parse("file:///android_asset/my_file.pdf");

// intent builder
var intent = DocumentActivity.IntentBuilder.FromActivityClass(this, Java.Lang.Class.FromType(typeof(DocumentActivity)))
    .WithUri(uri)
    .Build();
StartActivity(intent);
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Step 3: (Optional) Customize the viewer

* If you would like to customize the appearance of the viewer activity, define `PDFTronAppTheme` in `res/values/styles.xml`:You can learn more about this in the [customize the viewer's theme guide ](/xamarin/guides/viewer-components/custom-theme-a.md).

{% tabs %}
{% tab title="XML" %}
{% code lineNumbers="true" %}

```xml
<style name="PDFTronAppTheme" parent="PDFTronAppThemeBase"> <item name="colorPrimary">@color/app_color_primary_day</item> <item name="colorPrimaryDark">@color/app_color_primary_dark_day</item> <item name="colorAccent">@color/app_color_accent</item> <!-- Action bar --> <item name="actionModeBackground">?attr/colorPrimary</item> <item name="windowActionModeOverlay">true</item> </style>
```

{% endcode %}
{% endtab %}
{% endtabs %}

{% hint style="info" %}
`DocumentActivity` uses the `AppCompat` theme for material colors. Make sure that the value of `android:theme` in your `activity` tag also extends the `AppCompat` theme.
{% endhint %}

* Also, if you would like to customize the UI components in `DocumentActivity`, you can use [`ViewerConfig.Builder`](https://sdk.apryse.com/api/xamarinandroid/tools/api/pdftron.PDF.Config.ViewerConfig.Builder.html). For example:For details on customizing the UI and using `ViewerConfig.Builder`, check out the [configuration tutorial ](/xamarin/viewer/viewer-config.md).

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
var builder = new pdftron.PDF.Config.ViewerConfig.Builder();
var config = builder
    .FullscreenModeEnabled(true)
    .MultiTabEnabled(true)
    .DocumentEditingEnabled(true)
    .LongPressQuickMenuEnabled(true)
    .ToolbarTitle("Simple Reader")
    .ShowSearchView(true)
    .Build();
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/xamarin/guides/getting-started/using-activity.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
